=== debian/changelog ===
cmtk (2.1.0-1) unstable; urgency=low

  * Initial release (Closes: #626225)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 22 Nov 2011 20:00:37 -0500
